//ODEObject.h
//Base 3D object class with ODE support
//Author: Tyler Streeter

#ifndef __ODE_OBJECT_H__
#define __ODE_OBJECT_H__

#include "Base3DObject.h"
#include <string>
#include <ode/ode.h>

#define PI 3.14159265358979323846f
#define	DEG2RAD(x) (((x)*PI)/180.0)
#define	RAD2DEG(x) (((x)*180.0)/PI)

class ODEObject : public Base3DObject
{
public:
	//ODEObject();
	ODEObject(bool body, dReal posx, dReal posy, dReal posz);
	virtual ~ODEObject();
	virtual void Draw();
	void SetPosition(point3d newposition);
	point3d GetPosition();
	void SetOrientation(int axis, dReal angle); //crude for now
	//point3d GetOrientation();

	void SetVelocity(vector3d velocity);
	vector3d GetVelocity();

	dBodyID GetBodyID();
	void SetBodyID(dBodyID bodyID);
	dGeomID GetGeomID();
	void SetGeomID(dGeomID geomID);
	bool HasBody();

protected:

	// ODE stuff
	dBodyID thisBodyID;
	dGeomID thisGeomID;
	//vector3d velocity;
	bool hasBody;
};

#endif
